<template>
    <div class="order-request-execution">
      <ObForm
        :form-data="formData"
        ok-text="Снять исполнителя"
        :is-submit-disabled="isSubmitDisabled"
        data-qa="CancelExecutorModal"
        @submit="onSubmitHandler"
      >
        <div slot="title" class="ob-ty-modal-title">
          Отмена назначения исполнителя
          <br/>
          {{ order.executor && order.executor.title }}
        </div>
        <p class="mt20">
          У вас подписана заявка с {{ order.executor && order.executor.title }}. Вы уверены, что вы хотите снять этого исполнителя? Это приведет к отмене заявки и возможному возникновению претензии.
        </p>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          :upload-method="uploadMethod"
          @process-start="startUploadFiles"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObUploader from 'common-components/src/obComponents/obUploader'

export default {
  name: 'CancelExecutorModal',
  components: {
    ObForm,
    ObUploader
  },
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      formData: {
        fileUuid: null
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    isSubmitDisabled () {
      return this.formData.fileUuid === 'loading'
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    startUploadFiles () {
      this.formData.fileUuid = 'loading'
    },
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.fileUuid = null
        return
      }

      this.formData.fileUuid = data.uuid
    },
    async onSubmitHandler (data) {
      this.$emit('on-submitted', data)
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
    .mt20{
      margin-top: 20px;
    }
  }
</style>
